package cn.iocoder.yudao.module.llm.service.finetuningloss;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.llm.controller.admin.finetuningloss.vo.*;
import cn.iocoder.yudao.module.llm.dal.dataobject.finetuningloss.FineTuningLossDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.llm.dal.mysql.finetuningloss.FineTuningLossMapper;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.llm.enums.ErrorCodeConstants.*;

/**
 * 损失记录表，用于记录每次训练的损失值 Service 实现类
 *
 * @author 华大大模型
 */
@Service
@Validated
public class FineTuningLossServiceImpl implements FineTuningLossService {

    @Resource
    private FineTuningLossMapper fineTuningLossMapper;

    @Override
    public Long createFineTuningLoss(FineTuningLossSaveReqVO createReqVO) {
        // 插入
        FineTuningLossDO fineTuningLoss = BeanUtils.toBean(createReqVO, FineTuningLossDO.class);
        fineTuningLossMapper.insert(fineTuningLoss);
        // 返回
        return fineTuningLoss.getId();
    }

    @Override
    public void updateFineTuningLoss(FineTuningLossSaveReqVO updateReqVO) {
        // 校验存在
        validateFineTuningLossExists(updateReqVO.getId());
        // 更新
        FineTuningLossDO updateObj = BeanUtils.toBean(updateReqVO, FineTuningLossDO.class);
        fineTuningLossMapper.updateById(updateObj);
    }

    @Override
    public void deleteFineTuningLoss(Long id) {
        // 校验存在
        validateFineTuningLossExists(id);
        // 删除
        fineTuningLossMapper.deleteById(id);
    }

    private void validateFineTuningLossExists(Long id) {
        if (fineTuningLossMapper.selectById(id) == null) {
            throw exception(FINE_TUNING_LOSS_NOT_EXISTS);
        }
    }

    @Override
    public FineTuningLossDO getFineTuningLoss(Long id) {
        return fineTuningLossMapper.selectById(id);
    }

    @Override
    public PageResult<FineTuningLossDO> getFineTuningLossPage(FineTuningLossPageReqVO pageReqVO) {
        return fineTuningLossMapper.selectPage(pageReqVO);
    }

}